this.name        = "oolite-constrictor-hunt"; 
this.author      = "eric walch"; 
this.copyright   = " 2008 the Oolite team."; 
this.description = ""; 
this.version     = "1.71"; 

this.DISABLE=function(name)
{
    if (!this.old) this.old={};
    if (!name || name=='') return;
    if (!this.old[name])
            this.old[name]=this[name];
    //this[name]=function(){};
    delete this[name];
}

this.ENABLE=function(name)
{
    if (!name || name==''||!this.old) return;
    this[name]=this.old[name];
}
this.CLEANUP = function()
{ //can't check missionVariables inside startUp or reset
    if (missionVariables.conhunt == "MISSION_COMPLETE")
    {
        LogWithClass('script.Conhunt.cleanup', 'Conhunt finished. Disabling script.');
        //no need to run any of these!
        this.DISABLE("shipDockedWithStation");	
        this.DISABLE("shipLaunchedFromStation");
        this.DISABLE("shipExitedWitchspace");
        this.DISABLE("missionScreenEnded");
        this.DISABLE("missionChoiceWasReset");
        this.DISABLE("guiScreenChanged");
    } 
    else
    {
        if (this.old)
        {
            this.ENABLE("shipDockedWithStation");	
            this.ENABLE("shipLaunchedFromStation");
            this.ENABLE("shipExitedWitchspace");
            this.ENABLE("missionScreenEnded");		
            this.ENABLE("missionChoiceWasReset");		
            this.ENABLE("guiScreenChanged");		
            LogWithClass('script.Conhunt.cleanup', 'Conhunt script disabled previously. Re-enabling script.');
        }
    }
    this.cleanup=function(){}; // run just once per script startup/reset
}

this.addToScreen = function()
{
    if(guiScreen == "GUI_SCREEN_SYSTEM_DATA")
    {
        if(galaxyNumber == 0)
        {
            switch (system.ID)
            {
            case  28: mission.addMessageTextKey("constrictor_hunt_0_28"); break
            case  36: mission.addMessageTextKey("constrictor_hunt_0_36"); break
            case 150: mission.addMessageTextKey("constrictor_hunt_0_150"); break
            default: break;
            }
        }
        if(galaxyNumber == 1)
        {
            switch (system.ID)
            {
            case   3: 
            case   5:
            case  16:
            case  26:
            case  32:
            case  68:
            case 106:
            case 107:
            case 162:
            case 164:
            case 184:
            case 192:
            case 220: mission.addMessageTextKey("constrictor_hunt_1_A"); break
            case 253: mission.addMessageTextKey("constrictor_hunt_1_253"); break
            case  79: mission.addMessageTextKey("constrictor_hunt_1_79"); break
            case  53: mission.addMessageTextKey("constrictor_hunt_1_53"); break
            case 118: mission.addMessageTextKey("constrictor_hunt_1_118"); break
            case 193: mission.addMessageTextKey("constrictor_hunt_1_193"); break
            default: break;
            }
        }
    }
}

/*
All the screen offers look alike. Therefor a function is created that does the work. With a single call from other parts all the things are set. When a function has a value it is set and when null it is cleared.
*/
this.missionScreen=function(messageKey, backGround, choiceKey, ShipKey, MusicKey)
{
    mission.showShipModel(ShipKey);mission.setMusic(MusicKey);
    mission.setBackgroundImage(backGround);
    mission.showMissionScreen();
    mission.addMessageTextKey(messageKey);
    if (choiceKey) mission.setChoicesKey(choiceKey);
    mission.setBackgroundImage(); mission.setMusic();
}

this.missionOffers = function()
{
    if (guiScreen == "GUI_SCREEN_MISSION" || (mission.choice && mission.choice != "")) return; 
    // there will be a "missionScreenEnded" or a "missionChoiceWasReset" in future to react uppon.
    if (player.dockedStation.isMainStation)
    {
        if(galaxyNumber < 2 && !missionVariables.conhunt && player.score > 255)
        {
            this.missionScreen("constrictor_hunt_brief1", null, null, "constrictor");
            if(galaxyNumber == 0) mission.addMessageTextKey("constrictor_hunt_brief1a"); // galaxy = 0
            else mission.addMessageTextKey("constrictor_hunt_brief1b"); // galaxy = 1
            missionVariables.conhunt = "STAGE_1"
            mission.setInstructionsKey("conhunt_short_desc1") 
        }
        if(missionVariables.conhunt == "CONSTRICTOR_DESTROYED")  // Variable is set by the ship-script
        {
             this.missionScreen("constrictor_hunt_debrief", null, null, "constrictor");
             player.credits += 5000
             player.bounty = 0	// legal status
             player.score += 256 // shipkills
             mission.addMessageTextKey()  // reset the missionbriefing
             missionVariables.conhunt = "MISSION_COMPLETE"
        }
    }
}

this.setUpShips = function()
{
    if(missionVariables.conhunt == "STAGE_1" && galaxyNumber == 1 && system.ID == 193)
    {
        if(system.countShipsWithRole("constrictor") == 0) system.legacy_addShips("constrictor", 1)
    }
}

// below are the 7 eventhandlers that are triggered by the system.
this.startUp = this.reset = function()
{
    this.cleanup=this.CLEANUP;
}

this.shipWillLaunchFromStation = function(station)
{
    this.cleanup();
}

this.guiScreenChanged = function()
{
    if(galaxyNumber < 2 && missionVariables.conhunt == "STAGE_1") this.addToScreen()
}

this.shipDockedWithStation = function()
{
    this.missionOffers()
}

this.missionScreenEnded = this.missionChoiceWasReset = function()
{
    if(!player.docked) return;
    this.missionOffers()
}

this.shipExitedWitchspace = this.shipLaunchedFromStation = function()
{
    this.setUpShips();
}