this.name        = "oolite-thargoid-plans"; 
this.author      = "eric walch"; 
this.copyright   = " 2008 the Oolite team."; 
this.description = ""; 
this.version     = "1.71"; 

this.DISABLE=function(name)
{
    if (!this.old) this.old={};
    if (!name || name=='') return;
    if (!this.old[name])
            this.old[name]=this[name];
    //this[name]=function(){};
    delete this[name];
}

this.ENABLE=function(name)
{
    if (!name || name==''||!this.old) return;
    this[name]=this.old[name];
}
this.CLEANUP = function()
{ //can't check missionVariables inside startUp or reset
    if (missionVariables.thargplans == "MISSION_COMPLETE")
    {
        LogWithClass('script.thargoid-plans.cleanup', 'thargoid-plans finished. Disabling script.');
        //no need to run any of these!
        this.DISABLE("shipDockedWithStation");	
        this.DISABLE("shipLaunchedFromStation");
        this.DISABLE("shipExitedWitchspace");
        this.DISABLE("missionScreenEnded");
        this.DISABLE("missionChoiceWasReset");
    } 
    else
    {
        if (this.old)
        {
            this.ENABLE("shipDockedWithStation");	
            this.ENABLE("shipLaunchedFromStation");
            this.ENABLE("shipExitedWitchspace");
            this.ENABLE("missionScreenEnded");		
            this.ENABLE("missionChoiceWasReset");		
            LogWithClass('script.thargoid-plans.cleanup', 'thargoid-plans script disabled previously. Re-enabling script.');
        }
    }
    this.cleanup=function(){}; // run just once per script startup/reset
}

this.missionScreen=function(messageKey, backGround, choiceKey, ShipKey, MusicKey)
{
    mission.showShipModel(ShipKey);mission.setMusic(MusicKey);
    mission.setBackgroundImage(backGround);
    mission.showMissionScreen();
    mission.addMessageTextKey(messageKey);
    if (choiceKey) mission.setChoicesKey(choiceKey);
    mission.setBackgroundImage(); mission.setMusic();
}

this.missionOffers = function()
{
    if (guiScreen == "GUI_SCREEN_MISSION" || (mission.choice && mission.choice != "")) return; 
    // there will be a "missionScreenEnded" or a "missionChoiceWasReset" in future to react uppon.
    if (player.dockedStation.isMainStation)
    {
        if(galaxyNumber == 2)
        {
            if(!missionVariables.thargplans && missionVariables.conhunt == "MISSION_COMPLETE" && player.score > 1280 && system.ID != 83)
            {
                this.missionScreen("thargoid_plans_intro_brief");
                missionVariables.thargplans = "PRELUDE"
                mission.setInstructionsKey("thargplans_short_desc1")
                mission.markSystem(83)
            }
            if(missionVariables.thargplans == "PRELUDE" && system.ID == 83)
            {
                mission.unmarkSystem(83)
                this.missionScreen("thargoid_plans_main_brief", null, null, "thargoid");
                missionVariables.thargplans = "RUNNING"
                mission.setInstructionsKey("thargplans_short_desc2") 
                mission.markSystem(36)
            }
            if(missionVariables.thargplans == "RUNNING" && system.ID == 36)
            {
                this.missionScreen("thargoid_plans_debrief", null, null, "thargoid");
                player.score += 256 // shipkills
                mission.setInstructionsKey()  // reset the missionbriefing
                missionVariables.thargplans = "MISSION_COMPLETE"
                player.awardEquipment("EQ_NAVAL_ENERGY_UNIT")
                missionVariables.TL_FOR_EQ_NAVAL_ENERGY_UNIT = 13
                mission.unmarkSystem(36)
            }
        }
    }
}

this.addTargoids = function()
{
    this.loopcount++ // 5 loops of adding in the legacy script with a script timer.
    if(this.loopcount > 5) { this.targoidTimer.stop; return}
     if(system.countShipsWithRole("thargoid") < 2) 
     {
        system.legacy_addSystemShips("thargoid", 1, 0.33)
        system.legacy_addSystemShips("thargoid", 1, 0.66)
     }
     if(system.countShipsWithRole("thargoid") < 5 && Math.random() < 0.5) 
     {
        system.legacy_addShips("thargoid", 1)
     }
}


this.setUpShips = function()
{
    if(missionVariables.thargplans == "RUNNING" && galaxyNumber == 2)
    {
        if(this.targoidTimer) this.targoidTimer.start()
        else this.targoidTimer = new Timer(this, this.addTargoids, 10, 10)
    }
}

// below are the 7 eventhandlers that are triggered by the system.
this.startUp = this.reset = function()
{
    this.loopcount = 0  // should be zero on the first launch after a reset.
    this.cleanup=this.CLEANUP;
}

this.shipWillLaunchFromStation = function(station)
{
    this.cleanup();
}

this.shipDockedWithStation = function()
{
    this.missionOffers()
}

this.missionScreenEnded = this.missionChoiceWasReset = function()
{
    if(!player.docked) return;
    this.missionOffers()
}

this.shipLaunchedFromStation = function()
{
    this.setUpShips();
}
this.shipExitedWitchspace = function()
{
    this.loopcount = 0
    this.setUpShips();
}